#include <stdio.h>
#include "pgraph.h"
#include "norm-rand.h"

#define sigma 30
#define H 0.8
//#define H 0.08
//#define H 1
#define N 9

double *ordinates;
double deviations[N];

void create_bridge(int i, int j, int n)
{
	int s = (i + j) / 2;
	ordinates[s] = (ordinates[i] + ordinates[j]) / 2.0 + deviations[--n] * get_norm_rand_val();
	if (n)
	{
		create_bridge(i, s, n);
		create_bridge(s, j, n);
	}
}

int main()
{
	const double alpha = pow(2, H);
	deviations[N - 1] = sigma;
	for (int i = N - 1; i; i--)
		deviations[i - 1] = deviations [i] / alpha;
	const int pow2N = pow(2, N), size = pow2N + 1;
    ordinates = malloc(size * sizeof(double));
    ordinates[0] = ordinates[pow2N] = pow2N / 4;
	create_bridge(0, pow2N, N);
    image *img = create_image(size, pow2N / 2);
    img->cur_pnt = (point) {0, ordinates[0]};
    for (int i = 1; i <= pow2N; i++)
    	line_to(img, i, round(ordinates[i]));
    free(ordinates);
	save_to_file(img, "result.bmp");	
	free(img);
	return 0;
}
