#include "norm-rand.h"

#define sqrt_2 1.414213562373		//sqrt(2)
#define sqrt_pi_2 1.253314137316	//sqrt(pi / 2)
#define eps 1e-5

static const double val[] = {0.0,			//f_1(0.5)
					  		 0.253347,		//f_1(0.6)
					  		 0.524401,		//f_1(0.7)
					  		 0.841621,		//f_1(0.8)
					  		 1.281552,		//f_1(0.9)
					  		 1.880794};     //f_1(0.97)

double f_1(double x)
{
	if (x == 0.5)
		return 0.0;
	if (x < eps)
		return -4.3;
	if (x > 1 - eps)
		return 4.3;
	int sign = 1;
	if (x < 0.5)
	{
		x = 1 - x;
		sign = -1;
	}	
	double xk1 = val[(int) (round(10 *x) - 5)], xk;
	double b = 1 - 2 * x;
	do
	{
		xk = xk1;
		double t = xk / sqrt_2;
		xk1 = xk - sqrt_pi_2 * exp(t * t) * (erf(t) + b);
	}
	while (fabs(xk - xk1) >= eps);
	return sign == 1 ? xk1 : -xk1;
}

double get_norm_rand_val()
{
	return f_1(rand() / ((double) RAND_MAX));
}

